type token =
  | LOWER_ID of (string)
  | UPPER_ID of (string)
  | TYVAR of (string)
  | STRING of (string)
  | INTEGER of (int)
  | KW_FN
  | KW_VAL
  | KW_LET
  | KW_IN
  | KW_END
  | KW_DATATYPE
  | KW_FROM
  | KW_CODATATYPE
  | KW_TO
  | KW_USE
  | KW_EXIT
  | KW_SHOW
  | KW_IF
  | KW_THEN
  | KW_ELSE
  | KW_SET
  | LPAREN
  | RPAREN
  | DARROW
  | ARROW
  | COMMA
  | EQ
  | SEMICOLON
  | STAR
  | PLUS
  | LAMBDA
  | DOT
  | BAR
  | AND
  | SLASH
  | MINUS
  | OP

open Parsing;;
# 2 "parser.mly"
(*
 * Copyright (c) 2002, 2003 The University of Wroclaw.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	Wroclaw and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE UNIVERSITY AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *)
open Ast

let locus () =
  let fn = Lexer.get_file_name () in
  let (l, c) = Lexer.get_line_column fn (Parsing.symbol_start()) in
        {loc_file=fn;
         loc_char=c;
         loc_line=l}

let ice () = raise Parse_error

let locate x = {l = locus (); v = x}

let name n = {n_name = n; n_binding = None}
let tc n a = Tycon (name n, a)

# 91 "parser.ml"
let yytransl_const = [|
  262 (* KW_FN *);
  263 (* KW_VAL *);
  264 (* KW_LET *);
  265 (* KW_IN *);
  266 (* KW_END *);
  267 (* KW_DATATYPE *);
  268 (* KW_FROM *);
  269 (* KW_CODATATYPE *);
  270 (* KW_TO *);
  271 (* KW_USE *);
  272 (* KW_EXIT *);
  273 (* KW_SHOW *);
  274 (* KW_IF *);
  275 (* KW_THEN *);
  276 (* KW_ELSE *);
  277 (* KW_SET *);
  278 (* LPAREN *);
  279 (* RPAREN *);
  280 (* DARROW *);
  281 (* ARROW *);
  282 (* COMMA *);
  283 (* EQ *);
  284 (* SEMICOLON *);
  285 (* STAR *);
  286 (* PLUS *);
  287 (* LAMBDA *);
  288 (* DOT *);
  289 (* BAR *);
  290 (* AND *);
  291 (* SLASH *);
  292 (* MINUS *);
  293 (* OP *);
    0|]

let yytransl_block = [|
  257 (* LOWER_ID *);
  258 (* UPPER_ID *);
  259 (* TYVAR *);
  260 (* STRING *);
  261 (* INTEGER *);
    0|]

let yylhs = "\255\255\
\001\000\002\000\002\000\002\000\002\000\002\000\002\000\002\000\
\002\000\002\000\002\000\002\000\002\000\007\000\007\000\004\000\
\004\000\008\000\008\000\009\000\009\000\005\000\005\000\011\000\
\011\000\010\000\010\000\012\000\012\000\006\000\006\000\015\000\
\015\000\014\000\014\000\016\000\016\000\016\000\017\000\017\000\
\013\000\013\000\013\000\013\000\013\000\013\000\018\000\003\000\
\021\000\021\000\022\000\022\000\023\000\023\000\019\000\019\000\
\019\000\019\000\019\000\019\000\019\000\020\000\020\000\020\000\
\020\000\020\000\020\000\024\000\024\000\027\000\027\000\025\000\
\025\000\026\000\026\000\000\000"

let yylen = "\002\000\
\002\000\004\000\004\000\005\000\005\000\001\000\001\000\002\000\
\002\000\002\000\002\000\001\000\003\000\001\000\001\000\000\000\
\002\000\000\000\001\000\000\000\001\000\000\000\003\000\000\000\
\003\000\001\000\003\000\001\000\002\000\000\000\003\000\000\000\
\003\000\001\000\003\000\001\000\003\000\001\000\002\000\001\000\
\001\000\001\000\003\000\003\000\003\000\003\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\003\000\005\000\002\000\002\000\006\000\001\000\002\000\003\000\
\003\000\003\000\002\000\001\000\002\000\005\000\005\000\003\000\
\002\000\003\000\002\000\002\000"

let yydefred = "\000\000\
\000\000\000\000\015\000\014\000\056\000\000\000\000\000\000\000\
\000\000\000\000\000\000\006\000\000\000\000\000\000\000\000\000\
\000\000\000\000\076\000\000\000\000\000\055\000\062\000\048\000\
\000\000\059\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\009\000\008\000\000\000\000\000\011\000\010\000\
\000\000\000\000\000\000\060\000\049\000\050\000\051\000\052\000\
\053\000\054\000\067\000\001\000\000\000\000\000\063\000\047\000\
\000\000\000\000\000\000\073\000\000\000\000\000\000\000\000\000\
\000\000\069\000\000\000\000\000\000\000\000\000\057\000\000\000\
\075\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\017\000\000\000\000\000\000\000\000\000\
\000\000\000\000\058\000\019\000\004\000\000\000\021\000\005\000\
\000\000\000\000\070\000\071\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\023\000\000\000\000\000\031\000\040\000\
\042\000\000\000\027\000\000\000\000\000\000\000\035\000\000\000\
\000\000\000\000\000\000\000\000\029\000\038\000\036\000\000\000\
\039\000\025\000\033\000\043\000\000\000\000\000\045\000\000\000\
\037\000"

let yydgoto = "\002\000\
\019\000\020\000\021\000\068\000\093\000\096\000\022\000\094\000\
\097\000\102\000\108\000\115\000\116\000\104\000\111\000\129\000\
\117\000\055\000\023\000\024\000\057\000\058\000\051\000\031\000\
\026\000\044\000\032\000"

let yysindex = "\002\000\
\008\255\000\000\000\000\000\000\000\000\010\255\021\255\142\255\
\038\255\047\255\057\255\000\000\171\255\089\255\200\255\089\255\
\062\255\073\255\000\000\037\255\111\255\000\000\000\000\000\000\
\017\255\000\000\045\255\058\255\095\255\100\255\097\255\146\255\
\107\255\107\255\000\000\000\000\146\255\126\255\000\000\000\000\
\004\000\091\255\003\255\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\089\255\089\255\000\000\000\000\
\089\255\089\255\089\255\000\000\089\255\089\255\094\255\112\255\
\089\255\000\000\107\255\124\255\131\255\089\255\000\000\089\255\
\000\000\042\255\004\000\004\000\004\000\004\000\004\000\004\000\
\089\255\089\255\158\255\000\000\132\255\133\255\177\255\004\000\
\209\255\224\255\000\000\000\000\000\000\167\255\000\000\000\000\
\179\255\089\255\000\000\000\000\174\255\157\255\178\255\162\255\
\169\255\005\255\167\255\000\000\005\255\179\255\000\000\000\000\
\000\000\005\255\000\000\245\255\078\255\157\255\000\000\162\255\
\063\255\005\255\005\255\005\255\000\000\000\000\000\000\005\255\
\000\000\000\000\000\000\000\000\093\255\168\255\000\000\193\255\
\000\000"

let yyrindex = "\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\181\255\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\191\255\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\196\255\
\194\255\194\255\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\019\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\194\255\000\000\000\000\000\000\000\000\000\000\
\000\000\056\000\192\255\084\000\098\000\100\000\205\255\206\255\
\000\000\000\000\000\000\000\000\000\255\004\255\000\000\112\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\009\255\208\255\049\255\213\255\
\070\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\018\255\121\000\208\255\000\000\213\255\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\102\255\040\000\000\000\000\000\
\000\000"

let yygindex = "\000\000\
\000\000\000\000\017\000\223\255\000\000\000\000\023\000\000\000\
\000\000\117\000\110\000\152\255\019\001\133\000\129\000\000\000\
\000\000\000\000\235\255\235\000\238\000\239\000\000\000\226\000\
\244\000\220\000\000\000"

let yytablesize = 411
let yytable = "\056\000\
\069\000\018\000\001\000\043\000\119\000\020\000\112\000\113\000\
\003\000\004\000\025\000\125\000\005\000\006\000\007\000\008\000\
\056\000\025\000\009\000\056\000\010\000\027\000\011\000\012\000\
\013\000\014\000\114\000\022\000\015\000\016\000\038\000\030\000\
\041\000\084\000\072\000\036\000\026\000\040\000\017\000\033\000\
\059\000\026\000\003\000\004\000\018\000\028\000\005\000\006\000\
\034\000\037\000\028\000\028\000\056\000\056\000\056\000\056\000\
\056\000\056\000\056\000\014\000\035\000\056\000\043\000\016\000\
\052\000\056\000\056\000\056\000\056\000\074\000\075\000\061\000\
\017\000\076\000\077\000\078\000\034\000\079\000\080\000\126\000\
\127\000\083\000\034\000\056\000\062\000\132\000\087\000\122\000\
\088\000\003\000\004\000\123\000\124\000\005\000\006\000\063\000\
\037\000\089\000\090\000\128\000\064\000\045\000\046\000\046\000\
\046\000\065\000\014\000\047\000\048\000\067\000\016\000\003\000\
\004\000\071\000\105\000\005\000\006\000\122\000\037\000\017\000\
\081\000\123\000\124\000\046\000\046\000\018\000\003\000\004\000\
\014\000\046\000\005\000\006\000\016\000\037\000\046\000\046\000\
\053\000\054\000\082\000\045\000\046\000\017\000\028\000\014\000\
\070\000\047\000\048\000\016\000\029\000\030\000\085\000\053\000\
\029\000\030\000\045\000\046\000\017\000\086\000\003\000\004\000\
\047\000\048\000\005\000\006\000\092\000\037\000\095\000\091\000\
\101\000\003\000\004\000\003\000\004\000\005\000\006\000\014\000\
\037\000\003\000\004\000\016\000\103\000\005\000\006\000\053\000\
\037\000\106\000\045\000\046\000\017\000\107\000\016\000\109\000\
\047\000\048\000\014\000\110\000\098\000\124\000\016\000\017\000\
\003\000\004\000\053\000\039\000\068\000\045\000\046\000\017\000\
\007\000\003\000\004\000\047\000\048\000\005\000\006\000\137\000\
\037\000\122\000\012\000\013\000\016\000\123\000\124\000\118\000\
\003\000\004\000\014\000\130\000\005\000\006\000\016\000\037\000\
\002\000\003\000\053\000\024\000\099\000\045\000\046\000\017\000\
\032\000\014\000\120\000\047\000\048\000\016\000\112\000\113\000\
\131\000\053\000\042\000\100\000\045\000\046\000\017\000\049\000\
\050\000\066\000\047\000\048\000\003\000\004\000\073\000\000\000\
\005\000\006\000\114\000\037\000\060\000\122\000\000\000\000\000\
\000\000\123\000\124\000\048\000\048\000\014\000\000\000\048\000\
\048\000\016\000\048\000\000\000\000\000\053\000\000\000\000\000\
\045\000\046\000\017\000\000\000\048\000\000\000\047\000\048\000\
\048\000\044\000\044\000\000\000\048\000\000\000\000\000\048\000\
\048\000\048\000\000\000\000\000\000\000\048\000\048\000\000\000\
\000\000\000\000\000\000\000\000\000\000\044\000\044\000\000\000\
\044\000\064\000\000\000\044\000\044\000\000\000\000\000\000\000\
\044\000\044\000\064\000\064\000\000\000\000\000\064\000\061\000\
\000\000\064\000\064\000\064\000\064\000\064\000\000\000\000\000\
\061\000\061\000\064\000\064\000\061\000\065\000\000\000\061\000\
\061\000\061\000\061\000\061\000\000\000\000\000\065\000\065\000\
\061\000\061\000\065\000\066\000\000\000\072\000\065\000\065\000\
\000\000\000\000\000\000\000\000\066\000\066\000\072\000\072\000\
\066\000\074\000\072\000\000\000\066\000\066\000\072\000\072\000\
\000\000\000\000\074\000\074\000\121\000\000\000\074\000\000\000\
\000\000\000\000\074\000\074\000\133\000\134\000\135\000\041\000\
\000\000\041\000\136\000\000\000\041\000\041\000\041\000\000\000\
\000\000\041\000\041\000"

let yycheck = "\021\000\
\034\000\002\001\001\000\001\001\109\000\002\001\002\001\003\001\
\001\001\002\001\001\001\116\000\005\001\006\001\007\001\008\001\
\038\000\001\001\011\001\041\000\013\001\001\001\015\001\016\001\
\017\001\018\001\022\001\028\001\021\001\022\001\014\000\028\001\
\016\000\067\000\032\001\013\000\028\001\015\000\031\001\002\001\
\024\001\033\001\001\001\002\001\037\001\028\001\005\001\006\001\
\002\001\008\001\033\001\034\001\074\000\075\000\076\000\077\000\
\078\000\079\000\080\000\018\001\004\001\083\000\001\001\022\001\
\028\001\087\000\088\000\089\000\090\000\053\000\054\000\027\001\
\031\001\057\000\058\000\059\000\028\001\061\000\062\000\002\001\
\003\001\065\000\034\001\105\000\027\001\023\001\070\000\025\001\
\072\000\001\001\002\001\029\001\030\001\005\001\006\001\001\001\
\008\001\081\000\082\000\022\001\001\001\029\001\030\001\002\001\
\003\001\009\001\018\001\035\001\036\001\003\001\022\001\001\001\
\002\001\023\001\098\000\005\001\006\001\025\001\008\001\031\001\
\027\001\029\001\030\001\022\001\023\001\037\001\001\001\002\001\
\018\001\028\001\005\001\006\001\022\001\008\001\033\001\034\001\
\026\001\027\001\027\001\029\001\030\001\031\001\001\001\018\001\
\019\001\035\001\036\001\022\001\007\001\008\001\027\001\026\001\
\007\001\008\001\029\001\030\001\031\001\027\001\001\001\002\001\
\035\001\036\001\005\001\006\001\033\001\008\001\034\001\010\001\
\002\001\001\001\002\001\001\001\002\001\005\001\006\001\018\001\
\008\001\001\001\002\001\022\001\002\001\005\001\006\001\026\001\
\008\001\012\001\029\001\030\001\031\001\033\001\022\001\014\001\
\035\001\036\001\018\001\034\001\020\001\030\001\022\001\031\001\
\001\001\002\001\026\001\004\001\009\001\029\001\030\001\031\001\
\028\001\001\001\002\001\035\001\036\001\005\001\006\001\023\001\
\008\001\025\001\028\001\028\001\027\001\029\001\030\001\107\000\
\001\001\002\001\018\001\118\000\005\001\006\001\022\001\008\001\
\028\001\028\001\026\001\028\001\028\001\029\001\030\001\031\001\
\028\001\018\001\110\000\035\001\036\001\022\001\002\001\003\001\
\120\000\026\001\016\000\028\001\029\001\030\001\031\001\018\000\
\018\000\032\000\035\001\036\001\001\001\002\001\043\000\255\255\
\005\001\006\001\022\001\008\001\025\000\025\001\255\255\255\255\
\255\255\029\001\030\001\001\001\002\001\018\001\255\255\005\001\
\006\001\022\001\008\001\255\255\255\255\026\001\255\255\255\255\
\029\001\030\001\031\001\255\255\018\001\255\255\035\001\036\001\
\022\001\002\001\003\001\255\255\026\001\255\255\255\255\029\001\
\030\001\031\001\255\255\255\255\255\255\035\001\036\001\255\255\
\255\255\255\255\255\255\255\255\255\255\022\001\023\001\255\255\
\025\001\010\001\255\255\028\001\029\001\255\255\255\255\255\255\
\033\001\034\001\019\001\020\001\255\255\255\255\023\001\010\001\
\255\255\026\001\027\001\028\001\029\001\030\001\255\255\255\255\
\019\001\020\001\035\001\036\001\023\001\010\001\255\255\026\001\
\027\001\028\001\029\001\030\001\255\255\255\255\019\001\020\001\
\035\001\036\001\023\001\010\001\255\255\010\001\027\001\028\001\
\255\255\255\255\255\255\255\255\019\001\020\001\019\001\020\001\
\023\001\010\001\023\001\255\255\027\001\028\001\027\001\028\001\
\255\255\255\255\019\001\020\001\114\000\255\255\023\001\255\255\
\255\255\255\255\027\001\028\001\122\000\123\000\124\000\023\001\
\255\255\025\001\128\000\255\255\028\001\029\001\030\001\255\255\
\255\255\033\001\034\001"

let yynames_const = "\
  KW_FN\000\
  KW_VAL\000\
  KW_LET\000\
  KW_IN\000\
  KW_END\000\
  KW_DATATYPE\000\
  KW_FROM\000\
  KW_CODATATYPE\000\
  KW_TO\000\
  KW_USE\000\
  KW_EXIT\000\
  KW_SHOW\000\
  KW_IF\000\
  KW_THEN\000\
  KW_ELSE\000\
  KW_SET\000\
  LPAREN\000\
  RPAREN\000\
  DARROW\000\
  ARROW\000\
  COMMA\000\
  EQ\000\
  SEMICOLON\000\
  STAR\000\
  PLUS\000\
  LAMBDA\000\
  DOT\000\
  BAR\000\
  AND\000\
  SLASH\000\
  MINUS\000\
  OP\000\
  "

let yynames_block = "\
  LOWER_ID\000\
  UPPER_ID\000\
  TYVAR\000\
  STRING\000\
  INTEGER\000\
  "

let yyact = [|
  (fun _ -> failwith "parser")
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'raw_decl) in
    Obj.repr(
# 84 "parser.mly"
                        ( locate _1 )
# 390 "parser.ml"
               : Ast.decl))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 2 : string) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'term) in
    Obj.repr(
# 89 "parser.mly"
        ( Value_binding (_2, _4) )
# 398 "parser.ml"
               : 'raw_decl))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 2 : string) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'term) in
    Obj.repr(
# 91 "parser.mly"
        ( Value_binding (_2, _4) )
# 406 "parser.ml"
               : 'raw_decl))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 3 : string) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'tyvars) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'ctors) in
    Obj.repr(
# 93 "parser.mly"
        ( Type (_2, _3, _5) )
# 415 "parser.ml"
               : 'raw_decl))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 3 : string) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'tyvars) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'dtors) in
    Obj.repr(
# 95 "parser.mly"
        ( Cotype (_2, _3, _5) )
# 424 "parser.ml"
               : 'raw_decl))
; (fun __caml_parser_env ->
    Obj.repr(
# 97 "parser.mly"
        ( Exit_cmd )
# 430 "parser.ml"
               : 'raw_decl))
; (fun __caml_parser_env ->
    Obj.repr(
# 99 "parser.mly"
        ( Show_cmd "" )
# 436 "parser.ml"
               : 'raw_decl))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'any_id) in
    Obj.repr(
# 101 "parser.mly"
        ( Show_cmd _2 )
# 443 "parser.ml"
               : 'raw_decl))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 103 "parser.mly"
        ( Use_cmd _2 )
# 450 "parser.ml"
               : 'raw_decl))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'any_id) in
    Obj.repr(
# 105 "parser.mly"
        ( Set_cmd _2 )
# 457 "parser.ml"
               : 'raw_decl))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 107 "parser.mly"
        ( Set_cmd _2 )
# 464 "parser.ml"
               : 'raw_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'term) in
    Obj.repr(
# 109 "parser.mly"
        ( Term _1 )
# 471 "parser.ml"
               : 'raw_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'term) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'term) in
    Obj.repr(
# 111 "parser.mly"
        ( Eq_test (_1, _3) )
# 479 "parser.ml"
               : 'raw_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 115 "parser.mly"
                        ( _1 )
# 486 "parser.ml"
               : 'any_id))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 116 "parser.mly"
                        ( _1 )
# 493 "parser.ml"
               : 'any_id))
; (fun __caml_parser_env ->
    Obj.repr(
# 120 "parser.mly"
                                ( [] )
# 499 "parser.ml"
               : 'tyvars))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : string) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'tyvars) in
    Obj.repr(
# 121 "parser.mly"
                                ( _1 :: _2 )
# 507 "parser.ml"
               : 'tyvars))
; (fun __caml_parser_env ->
    Obj.repr(
# 124 "parser.mly"
                       (())
# 513 "parser.ml"
               : 'maybe_bar))
; (fun __caml_parser_env ->
    Obj.repr(
# 124 "parser.mly"
                                  (())
# 519 "parser.ml"
               : 'maybe_bar))
; (fun __caml_parser_env ->
    Obj.repr(
# 125 "parser.mly"
                       (())
# 525 "parser.ml"
               : 'maybe_and))
; (fun __caml_parser_env ->
    Obj.repr(
# 125 "parser.mly"
                                  (())
# 531 "parser.ml"
               : 'maybe_and))
; (fun __caml_parser_env ->
    Obj.repr(
# 128 "parser.mly"
                                ( [] )
# 537 "parser.ml"
               : 'ctors))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'maybe_bar) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'ctor) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'ctor_list) in
    Obj.repr(
# 129 "parser.mly"
                                ( _2 :: _3 )
# 546 "parser.ml"
               : 'ctors))
; (fun __caml_parser_env ->
    Obj.repr(
# 133 "parser.mly"
                                ( [] )
# 552 "parser.ml"
               : 'ctor_list))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'ctor) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'ctor_list) in
    Obj.repr(
# 134 "parser.mly"
                                ( _2 :: _3 )
# 560 "parser.ml"
               : 'ctor_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 138 "parser.mly"
                                ( {cd_name = _1; cd_args = []} )
# 567 "parser.ml"
               : 'ctor))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : string) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'ty_list) in
    Obj.repr(
# 139 "parser.mly"
                                ( {cd_name = _1; cd_args = _3} )
# 575 "parser.ml"
               : 'ctor))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'ty) in
    Obj.repr(
# 143 "parser.mly"
                        ( [_1] )
# 582 "parser.ml"
               : 'ty_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'ty) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'ty_list) in
    Obj.repr(
# 144 "parser.mly"
                        ( _1 :: _2 )
# 590 "parser.ml"
               : 'ty_list))
; (fun __caml_parser_env ->
    Obj.repr(
# 148 "parser.mly"
                                ( [] )
# 596 "parser.ml"
               : 'dtors))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'maybe_and) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'dtor) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'dtor_list) in
    Obj.repr(
# 149 "parser.mly"
                                ( _2 :: _3 )
# 605 "parser.ml"
               : 'dtors))
; (fun __caml_parser_env ->
    Obj.repr(
# 153 "parser.mly"
                                ( [] )
# 611 "parser.ml"
               : 'dtor_list))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'dtor) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'dtor_list) in
    Obj.repr(
# 154 "parser.mly"
                                ( _2 :: _3 )
# 619 "parser.ml"
               : 'dtor_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 158 "parser.mly"
                                ( {cd_name = _1; cd_args = []} )
# 626 "parser.ml"
               : 'dtor))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : string) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'ty_list) in
    Obj.repr(
# 159 "parser.mly"
                                ( {cd_name = _1; cd_args = _3} )
# 634 "parser.ml"
               : 'dtor))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 163 "parser.mly"
                                         ( Tyvar _1 )
# 641 "parser.ml"
               : 'aty))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'ty) in
    Obj.repr(
# 164 "parser.mly"
                                         ( _2 )
# 648 "parser.ml"
               : 'aty))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 165 "parser.mly"
                                         ( tc _1 [] )
# 655 "parser.ml"
               : 'aty))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'ty_app) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'aty) in
    Obj.repr(
# 169 "parser.mly"
                    ( 
       match _1 with 
       | Tycon (n, a) -> Tycon (n, a @ [_2])
       | _ -> assert false
    )
# 667 "parser.ml"
               : 'ty_app))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 174 "parser.mly"
                                         ( tc _1 [] )
# 674 "parser.ml"
               : 'ty_app))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'ty_app) in
    Obj.repr(
# 178 "parser.mly"
                          ( _1 )
# 681 "parser.ml"
               : 'ty))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 179 "parser.mly"
                                         ( Tyvar _1 )
# 688 "parser.ml"
               : 'ty))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'ty) in
    Obj.repr(
# 180 "parser.mly"
                                         ( _2 )
# 695 "parser.ml"
               : 'ty))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'ty) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'ty) in
    Obj.repr(
# 181 "parser.mly"
                                         ( tc "PAIR" [_1; _3] )
# 703 "parser.ml"
               : 'ty))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'ty) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'ty) in
    Obj.repr(
# 182 "parser.mly"
                                         ( tc "UNION" [_1; _3] )
# 711 "parser.ml"
               : 'ty))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'ty) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'ty) in
    Obj.repr(
# 183 "parser.mly"
                                         ( tc "->" [_1; _3] )
# 719 "parser.ml"
               : 'ty))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'raw_aterm) in
    Obj.repr(
# 187 "parser.mly"
                                         ( locate _1 )
# 726 "parser.ml"
               : 'aterm))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'raw_term) in
    Obj.repr(
# 191 "parser.mly"
                                        ( locate _1 )
# 733 "parser.ml"
               : 'term))
; (fun __caml_parser_env ->
    Obj.repr(
# 195 "parser.mly"
                                           ( OP_mul )
# 739 "parser.ml"
               : 'raw_binop_f))
; (fun __caml_parser_env ->
    Obj.repr(
# 196 "parser.mly"
                                           ( OP_plus )
# 745 "parser.ml"
               : 'raw_binop_f))
; (fun __caml_parser_env ->
    Obj.repr(
# 199 "parser.mly"
                                          ( OP_div )
# 751 "parser.ml"
               : 'raw_binop_r))
; (fun __caml_parser_env ->
    Obj.repr(
# 200 "parser.mly"
                                           ( OP_minus )
# 757 "parser.ml"
               : 'raw_binop_r))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'raw_binop_f) in
    Obj.repr(
# 203 "parser.mly"
                                          ( _1 )
# 764 "parser.ml"
               : 'raw_binop))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'raw_binop_r) in
    Obj.repr(
# 204 "parser.mly"
                                          ( _1 )
# 771 "parser.ml"
               : 'raw_binop))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'any_id) in
    Obj.repr(
# 207 "parser.mly"
                                         ( T_ref _1 )
# 778 "parser.ml"
               : 'raw_aterm))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : int) in
    Obj.repr(
# 208 "parser.mly"
                                         ( T_int _1 )
# 785 "parser.ml"
               : 'raw_aterm))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'raw_term) in
    Obj.repr(
# 210 "parser.mly"
                                         ( _2 )
# 792 "parser.ml"
               : 'raw_aterm))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 3 : 'value_binding_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'term) in
    Obj.repr(
# 212 "parser.mly"
                                         ( T_let (_2, _4) )
# 800 "parser.ml"
               : 'raw_aterm))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'fn_vars) in
    Obj.repr(
# 213 "parser.mly"
                                         ( _2 )
# 807 "parser.ml"
               : 'raw_aterm))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'lambda_vars) in
    Obj.repr(
# 214 "parser.mly"
                                         ( _2 )
# 814 "parser.ml"
               : 'raw_aterm))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 4 : 'term) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : 'term) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : 'term) in
    Obj.repr(
# 216 "parser.mly"
        ( T_app (locate (T_app (locate (T_app (locate (T_ref "_BOOLit"), _2)), _4)), _6) )
# 823 "parser.ml"
               : 'raw_aterm))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'raw_aterm) in
    Obj.repr(
# 220 "parser.mly"
                                            ( _1 )
# 830 "parser.ml"
               : 'raw_term))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'term) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'aterm) in
    Obj.repr(
# 221 "parser.mly"
                                            ( T_app (_1, _2) )
# 838 "parser.ml"
               : 'raw_term))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'term) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'term) in
    Obj.repr(
# 223 "parser.mly"
        ( T_app (locate (T_app (locate (T_ref "Pair"), _1)), _3) )
# 846 "parser.ml"
               : 'raw_term))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'term) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'raw_binop_f) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'term) in
    Obj.repr(
# 225 "parser.mly"
        ( T_app (locate (T_app (locate (T_binop _2), _1)), _3) )
# 855 "parser.ml"
               : 'raw_term))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'term) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'raw_binop_r) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'term) in
    Obj.repr(
# 227 "parser.mly"
        ( T_app (locate (T_app (locate (T_binop _2), _3)), _1) )
# 864 "parser.ml"
               : 'raw_term))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'raw_binop) in
    Obj.repr(
# 229 "parser.mly"
                                            (T_binop _2)
# 871 "parser.ml"
               : 'raw_term))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'value_binding) in
    Obj.repr(
# 233 "parser.mly"
                                                ( [_1] )
# 878 "parser.ml"
               : 'value_binding_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'value_binding) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'value_binding_list) in
    Obj.repr(
# 234 "parser.mly"
                                                ( _1 :: _2 )
# 886 "parser.ml"
               : 'value_binding_list))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 3 : string) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'term) in
    Obj.repr(
# 238 "parser.mly"
                                                  ( (_2, _4) )
# 894 "parser.ml"
               : 'value_binding))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 3 : string) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'term) in
    Obj.repr(
# 239 "parser.mly"
                                                  ( (_2, _4) )
# 902 "parser.ml"
               : 'value_binding))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : string) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'term) in
    Obj.repr(
# 243 "parser.mly"
                                ( T_abs (_1, _3) )
# 910 "parser.ml"
               : 'fn_vars))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : string) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'fn_vars) in
    Obj.repr(
# 244 "parser.mly"
                                ( T_abs (_1, locate _2) )
# 918 "parser.ml"
               : 'fn_vars))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : string) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'term) in
    Obj.repr(
# 248 "parser.mly"
                                ( T_abs (_1, _3) )
# 926 "parser.ml"
               : 'lambda_vars))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : string) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'lambda_vars) in
    Obj.repr(
# 249 "parser.mly"
                                ( T_abs (_1, locate _2) )
# 934 "parser.ml"
               : 'lambda_vars))
(* Entry decl *)
; (fun __caml_parser_env -> raise (Parsing.YYexit (Parsing.peek_val __caml_parser_env 0)))
|]
let yytables =
  { Parsing.actions=yyact;
    Parsing.transl_const=yytransl_const;
    Parsing.transl_block=yytransl_block;
    Parsing.lhs=yylhs;
    Parsing.len=yylen;
    Parsing.defred=yydefred;
    Parsing.dgoto=yydgoto;
    Parsing.sindex=yysindex;
    Parsing.rindex=yyrindex;
    Parsing.gindex=yygindex;
    Parsing.tablesize=yytablesize;
    Parsing.table=yytable;
    Parsing.check=yycheck;
    Parsing.error_function=parse_error;
    Parsing.names_const=yynames_const;
    Parsing.names_block=yynames_block }
let decl (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (Parsing.yyparse yytables 1 lexfun lexbuf : Ast.decl)
